/*********** Canyon Beast region ***********/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 972)
(use "controls")
(use "feature")
(use "cycle")
(use "follow")
(use "wander")
(use "game")
(use "main")
(use "obj")

(local
	catchCBeast = FALSE
)

(instance public CanyonB of Rgn
	(properties)
	
		(method (init)
			(super:init())
			(self:setScript(cBScript))
			
		// Make a CanyonBeast that ignores you
			(cBeast:
				ignoreActors()
				setCycle(Walk)
				setMotion(Wander)
				init()
			)
		)
)

(instance cBScript of Script
	(properties)
	
	(method (changeState newState)
		(=state newState)
		(switch (newState)
			(case 0
				// Do nothing
			)
			(case 10
				// Make the Canyon Beast walk to the edge of the screen
				(cBeast:setMotion (MoveTo 0 150 cBScript))
			)
			(case 11
				// ...and disappear
				(cBeast:hide())
			)
		)
	)
	
	(method (doit)
		(super:doit())
		// You need to be at a point of the game where the Canyon Beast will follow you, otherwise
		// the Canyon Beast will continue to ignore you.
	)
	
	(method (handleEvent pEvent)
		(var dyingScript)
		(super:handleEvent(pEvent))
			/* Can't take the Canyon Beast */
	        (if(Said('get,take / beast'))
        		Print("It escaped")
        		(self:changeState(10))
			)

			/* Can't eat the Canyon Beast */
			(if(Said('eat,drink / beast'))
				Print("You are joking, right?")
				(self:changeState(10))
			)
			
			/* You can ride the Canyon Beast */
			(if(Said('ride/beast'))
				(if(== gWhereAmI iosCANYONBEAST)
					(cBeast:hide())
					(send gGame:changeScore(3))
					= gWhereAmI (+ gWhereAmI 1)
					(send gEgo:view(3)cel(0)setMotion(NULL)setCycle(Fwd))
				)(else
					Print("You can't do that, yet.")
				 )
			)

        	/* Game over */
        	(if(Said('kill/beast'))
        		= dyingScript ScriptID(DYING_SCRIPT)
        		(send dyingScript:
        			caller(4)
        			register("A thunder splits the sky! It is the triumphant voice of Omegan...'Well done Alphan! The means become the end...I claim you as my own! Ha ha hah!'  You have failed, the evil one succeeds")
				)
				(send gGame:setScript(dyingScript))
			)
	)
)

(instance cBeast of Act
	(properties
		x 140
		y 140
		view 1
	)
)
						
/******************************************************************************/
