/******************************************************************************
 SCI Template Game
 By Brian Provinciano
 ******************************************************************************
 rm001.sc
 Contains the first room of your game. 
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 1)
/******************************************************************************/
(use "main")
(use "controls")
(use "cycle")
(use "game")
(use "feature")
(use "obj")
(use "inv")
(use "door")
(use "jump")
(use "dpath")

/*-*-* Define local varaible *-*-*/
(local
	randomBeast = 0
	enterRoom FALSE
)

/******************************************************************************/
(instance public rm001 of Rm
	(properties
		picture scriptNumber
		// Set up the rooms to go to/come from here
		north 0
		east 0
		south 0
		west 2
	)
	(method (init)
		// same in every script, starts things up
  		(super:init())
  		(self:setScript(RoomScript))

		// Health counter
		(if(== enterRoom FALSE)
			(self:setRegions(973))
			(= enterRoom TRUE)
		)
  		
  		// Inventory handler
  		(self:setRegions(971))
  		
  		// Check which room ego came from and position it
  		(switch(gPreviousRoomNumber)
            /******************************************************
             * Put the cases here for the rooms ego can come from *
             ******************************************************/
            (case west
  				(send gEgo:
  					posn(20 172)
  					loop(0)
  				)
  			)
            // Set up ego's position if it hasn't come from any room
  			(default
  				(send gEgo:
  					posn(88 170)
  					loop(1)
  				)
  			)
  		)
		
		// Set up the ego
		SetUpEgo()		
		(send gEgo:init())

		(if(== gLeafyP 0)
			Print("The land is still in darkness and Omegan still lives on his Island of Secrets. \n"+
			      "No-one found the objects or discovered the secret of Omegan's long life, though there are rumors of some who have tried."
			      )
			Print("Tales are told, for instance, of a wanderer named Median who entered the Castle of Secrets. \n"+
			      "He even drew a plan, they say, which he put into a bottle and thre into the Lake. It's a rumor that might be true."
			      )
			Print("No-one thought you, Alphan, would take on the task. \n"+
			      "Intelligent and wise you are, but are you strong to wrestle with the will of the Omegan? \n"+
			      "What if you really can bring the Earth back to normal?"
				 )
			= gLeafyP (+ gLeafyP 1)
					
		)
		
		// 5% chance of seeing the Canyon Beast in this room
		= randomBeast Random(1 100) 
		(if(>= randomBeast 95)		
			(self:setRegions(972))				
			(if(== gSeeCBeast 0)
				Print("There is a Canyon Beast here. You won't be able to catch one without help")
				= gSeeCBeast (+ gSeeCBeast 1)
			)
		)

	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
	(method (handleEvent pEvent)
		(var dyingScript)		
        (super:handleEvent(pEvent))

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
        (if (Said('look>'))
			(if (Said('/rock'))Print("The huge rock is blocking the path to the north."))
			(if (Said('/trees'))Print("The thick patch of trees is blocking the path to the north."))
			// this will handle just "look" by itself, and also "look around"
			(if (Said('[/around]'))Print("You are on a leafy path.")
				(if(>= randomBeast 95)Print("There is a Canyon Beast here")))				
			(if (Said('/*'))Print("There's nothing interesting about it."))
		)		
	)

)

/******************************************************************************
March 23, 2012 -- Examine the following to get a clear explanation on how to handle
look statements:

http://sciprogramming.com/tutor.php?id=37

August 2, 2012 -- The ceiling for health points the player can ever obtain in this game is 200. 

*****/