/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 5)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")

/*-*-* Define local varaible *-*-*/
(local
	enterRoom FALSE
)

/******************************************************************************/
(instance public rm005 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 4
		west 0
	)
	(method (init)
		(super:init())
		(if(not (send gEgo:has(INV_MUSHROOMS)))
		   (Mushrooms:
		   	   init()
		   	   setCycle(Fwd)
		   )
		   Print("There are mushrooms here.")
		)
		(self:setScript(RoomScript))

		// Health counter
		(if(== enterRoom FALSE)
			(self:setRegions(973))
			(= enterRoom TRUE)
		)

  		// Inventory handler
  		(self:setRegions(971))
		
		(switch(gPreviousRoomNumber)
			(case south
				(send gEgo:
					posn(275 175)
					loop(1)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
    (if(== (send gEgo:onControl()) ctlRED)
      (send gRoom:newRoom(4))
      )
	)

	(method (handleEvent pEvent)
        (super:handleEvent(pEvent))

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
        (if (Said('look>'))
			(if (Said('/cave'))Print("The only way out of this cave is the way you came in"))
			(if (Said('/mushrooms'))
				(if(== gWhereAmI iosMUSHROOM)
					(if(not (send gEgo:has(INV_MUSHROOMS)))
             			Print("There is a patch of mushrooms here...with something in it")
					)(else
						Print("You already have them"))
				)(else
					Print("There is a patch of mushrooms here")))
			// this will handle just "look" by itself, and also "look around"
			(if (Said('[/around]'))Print("You are in the inner chamber of Snelm's Lair")
        		(if(not (send gEgo:has(INV_MUSHROOMS)))Print("There are mushrooms here")))
			(if (Said('/*'))Print("There's nothing interesting about it."))
		)

        (if(Said('get,take / mushrooms'))
		   (if(== gWhereAmI iosMUSHROOM)
		   	(if(send gEgo:has(INV_MUSHROOMS))
              Print("You got them already!")
			)(else
            (if(send gEgo:inRect(150 132 180 144))
             Print("Done.")
             (send gEgo:get(INV_MUSHROOMS))
             (Mushrooms:hide())
             (send gGame:changeScore(3))
             = gWhereAmI (+ gWhereAmI 1)
			)(else
             Print("You're not close enough.")
			 )
			 )
		   )(else
		   	Print("You can't do that, yet.")
			)
		)
	)
)
/******************************************************************************/
(instance Mushrooms of Prop
  (properties
    y 138
    x 160
    view 400
  )
)
/******************************************************************************
Notes: The user can see the mushrooms in this room. If he hasn't completed any
of the previous tasks, he can't interact with them. This game takes form of the
very early Kings Quest games where the player collects objects, but they don't
serve any other purpose.
******************************************************************************/
