/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 6)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "Wander")

/*-*-* Define local varaible *-*-*/
(local
	randomBeast = 0
	enterRoom FALSE
)

/******************************************************************************/
(instance public rm006 of Rm
	(properties
		picture scriptNumber
		north 0
		east 7
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)

			(case east
				(send gEgo:
					posn(253 156)
					loop(1)
				)
			)

		)
		
		SetUpEgo()
		(send gEgo:init())
		
		// Health counter
		(if(== enterRoom FALSE)
			(self:setRegions(973))
			(= enterRoom TRUE)
		)
		
  		// Inventory handler
  		(self:setRegions(971))		
		
		// 50% chance of seeing the Canyon Beast in this room
		= randomBeast Random(1 100) 
		(if(>= randomBeast 50)		
			(self:setRegions(972))			
			(if(== gSeeCBeast 0)
				Print("There is a Canyon Beast here. You won't be able to catch one without help")
				= gSeeCBeast (+ gSeeCBeast 1)
			)
		)

	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (handleEvent pEvent)		
        (super:handleEvent(pEvent))

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
        (if (Said('look>'))
			(if (Said('/trees'))Print("The thick covering of bushes and trees blocks your way to the north and west"))
			(if (Said('/rocks'))Print("The rocks blocks your way to the south"))
			// this will handle just "look" by itself, and also "look around"
			(if (Said('[/around]'))Print("You are in the furthest depths of the forest.")
				(if(>= randomBeast 50)Print("There is a Canyon Beast here")))			
			(if (Said('/*'))Print("There's nothing interesting about it."))
		)
      )

)
/******************************************************************************/
/* Changes: 
Feb 28, 2012 - The map was confusing, at least in how I drew it out. I removed exit SOUTH into Snelm's Lair.
March 23, 2012 - I can't get Avoid to work for some reason. So for now, I'm having the Canyon Beast wander, until the user captures him.
March 23, 2012 - I've added the Canyon Beast to multiple rooms to correspond with the book's interpretation */
