/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 8)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "Wander")

/*-*-* Define local varaible *-*-*/
(local
	randomBeast = 0
	enterRoom FALSE
)

/******************************************************************************/
(instance public rm008 of Rm
	(properties
		picture scriptNumber
		north 9
		east 0
		south 0
		west 3
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))

		// Health counter
		(if(== enterRoom FALSE)
			(self:setRegions(973))
			(= enterRoom TRUE)
		)

  		// Inventory handler
  		(self:setRegions(971))
		
		(switch(gPreviousRoomNumber)
			(case west
				(send gEgo:
					posn(10 130)
					loop(0)
				)
			)
			(case north
				(send gEgo:
					posn(150 115)
					loop(2)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init())
		
		// 40% chance of seeing the Canyon Beast in this room
		= randomBeast Random(1 100) 
		(if(>= randomBeast 60)	
			(self:setRegions(972))				
			(if(== gSeeCBeast 0)
				Print("There is a Canyon Beast here. You won't be able to catch one without help")
				= gSeeCBeast (+ gSeeCBeast 1)
			)
		)

	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
       (if(== (send gEgo:onControl()) ctlRED)
         (send gRoom:newRoom(9))
	   )
	)

	(method (handleEvent pEvent)
        (super:handleEvent(pEvent))

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
        (if (Said('look>'))
			(if (Said('/branches'))Print("There is a very large pile of broken branches."))
			(if (Said('/stumps'))Print("The stumps, spring and a very large rock blocks your way the the south"))
			(if (Said('/rock'))Print("The stumps, spring and a very large rock blocks your way the the south"))
			(if (Said('/spring'))Print("The water in the spring looks very refreshing and drinkable"))
			// this will handle just "look" by itself, and also "look around"
			(if (Said('[/around]'))Print("You are by broken branches")
				Print("You see a sparkling freshwater spring.")
				        (if(>= randomBeast 60)Print("There is a Canyon Beast here")))
			(if (Said('/*'))Print("There's nothing interesting about it."))
		)
		
        (if(Said('drink/water'))
           (if(send gEgo:inRect(95 139 203 185))
             Print("Refreshing!")
			 (= gTotalHealth (+ gTotalHealth 7))
             (if(> gTotalHealth 200)
             	(= gTotalHealth 200)
			 )
           )(else
             Print("You're not close enough.")
			)
		)

	)

)
/******************************************************************************/
