/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 9)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "Wander")

/*-*-* Define local varaible *-*-*/
(local
	randomBeast = 0
	enterRoom FALSE
)

/******************************************************************************/
(instance public rm009 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 8
		west 7
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))

		// Health counter
		(if(== enterRoom FALSE)
			(self:setRegions(973))
			(= enterRoom TRUE)
		)

  		// Inventory handler
  		(self:setRegions(971))
  					
		(switch(gPreviousRoomNumber)
			(case south
				(send gEgo:
					posn(160 180)
					loop(3)
				)
			)
			(case west
				(send gEgo:
					posn(10 135)
					loop(0)
				)
			)			
		)
		
		SetUpEgo()
		(send gEgo:init())
		
		// 65% chance of seeing the Canyon Beast in this room
		= randomBeast Random(1 100) 
		(if(>= randomBeast 65)	
			(self:setRegions(972))				
			(if(== gSeeCBeast 0)
				Print("There is a Canyon Beast here. You won't be able to catch one without help")
				= gSeeCBeast (+ gSeeCBeast 1)
			)
		)		
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
        (super:handleEvent(pEvent))

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
        (if (Said('look>'))
			(if (Said('/trees'))Print("There aren't very many trees in this clearing."))
			(if (Said('/ledge'))Print("There is a ledge here that blocks your way to the north"))
			// this will handle just "look" by itself, and also "look around"
			(if (Said('[/around]'))Print("You are on a path out of the overgrown depths")
				(if(>= randomBeast 65)Print("There is a Canyon Beast here")))
			(if (Said('/*'))Print("There's nothing interesting about it."))
		)
	)
)
/******************************************************************************/
